#include "fivewin.ch"
#include "xbrowse.ch"

STATIC c_path, c_path1, c_path2, oFont, oFont1, oFont2, oFont3
STATIC nDStyle := 2, nDColorF := 16765559, nDColorB := 255
STATIC nDTxtColor := 255, nDGradpos := 0, LDDirect := .T.
STATIC cDBrush := "Marble.bmp" 

STATIC n1_GradC1, n1_GradC2, c1_GradArr, l1_GradDir, n1_Gradpos, l1_Grad 
STATIC n2_GradC1, n2_GradC2, c2_GradArr, l2_GradDir, n2_Gradpos, l2_Grad
STATIC n3_GradC1, n3_GradC2, c3_GradArr, l3_GradDir, n3_Gradpos, l3_Grad
STATIC n4_GradC1, n4_GradC2, c4_GradArr, l4_GradDir, n4_Gradpos, l4_Grad
STATIC n5_GradC1, n5_GradC2, c5_GradArr, l5_GradDir, n5_Gradpos, l5_Grad

FUNCTION MAIN()
LOCAL oDlg1, oFld1, oFBtn1, oFBtn2, oFBtn3, oFBtn4, aBitmaps, oGrd[5], oRGBBtn[5]

SETBALLOON( .T. ) // Balloon shape required for tooltips
REQUEST DBFCDX
RDDSETDEFAULT ( "DBFCDX" )

c_path := cFilePath(GetModuleFileName( GetInstance() ) )
c_path1 := c_Path + "SYSTEM\"

DEFINE FONT oFont NAME "ARIAL" SIZE 0,-10
DEFINE FONT oFont1 NAME "ARIAL" SIZE 0,-12 
DEFINE FONT oFont2 NAME "ARIAL" SIZE 0,-14 
DEFINE FONT oFont3 NAME "ARIAL" SIZE 0,-16 BOLD 

aBitmaps := { c_path1 + "Paint.Bmp",;
                          c_path1 + "Paint.bmp",;
                          c_path1 + "Paint.bmp",;
                          c_path1 + "Paint.bmp",;
                          c_path1 + "Paint.bmp",;
                          c_path1 + "Exit.bmp" }

DEFINE DIALOG oDlg1 TITLE "Folder RGB-colors   => " SIZE 760, 550 PIXEL 

GO_START()
LOAD_DBF(oDlg1, .F.)

@ 15, 10 FOLDEREX SIZE 360, 220 oFld1 PIXEL ROUND 5 UPDATE ;
PROMPT  "Gradient &1", "Gradient &2", "Gradient &3", "Gradient &4", "Gradient &5" OF oDlg1 ;
BITMAPS aBitmaps;
ON PAINT TAB PaintTab( Self, nOption );
ON CHANGE ( nSavePage := oFld1:nOption, ::Refresh() ) ;                         
ON PAINT TEXT( If( nOption == ::nOption .and. nOption == 2, 8388608, 0 ) );
TOP OPTION 1 ALIGN 0, 0, 0, 0, 0 UPDATE

oFld1:lTransparent := .T.
oFld1:nFolderHeight := 30
oFld1:nSeparator := 2
oFld1:bClrText := {| o, n | 128 }
oFld1:oFont := oFont1
oFld1:nOption := 1

@ 175, 290  BTNBMP oRGBBtn[1] OF oFld1:aDialogs[ 1 ] ;
SIZE 55, 22 PIXEL 2007 ; 
NOBORDER ;
PROMPT " &Show RGB" ;
FILENAME c_path1 + "Paint.Bmp" ;
ACTION SHOW_RGB(oFld1, 1) ;
LEFT
oRGBBtn[1]:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oRGBBtn[1]:lTransparent := .t.   
oRGBBtn[1]:cToolTip =  { "Show RGB","RGB", 1, CLR_BLACK, 14089979 }
oRGBBtn[1]:SetColor( 0, )

@ 175, 290  BTNBMP oRGBBtn[2] OF oFld1:aDialogs[ 2 ] ;
SIZE 55, 22 PIXEL 2007 ; 
NOBORDER ;
PROMPT " &Show RGB" ;
FILENAME c_path1 + "Paint.Bmp" ;
ACTION SHOW_RGB(oFld1, 2) ;
LEFT
oRGBBtn[2]:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oRGBBtn[2]:lTransparent := .t.   
oRGBBtn[2]:cToolTip =  { "Show RGB","RGB", 1, CLR_BLACK, 14089979 }
oRGBBtn[2]:SetColor( 0, )

@ 175, 290  BTNBMP oRGBBtn[3] OF oFld1:aDialogs[ 3 ] ;
SIZE 55, 22 PIXEL 2007 ; 
NOBORDER ;
PROMPT " &Show RGB" ;
FILENAME c_path1 + "Paint.Bmp" ;
ACTION SHOW_RGB(oFld1, 3) ;
LEFT
oRGBBtn[3]:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oRGBBtn[3]:lTransparent := .t.   
oRGBBtn[3]:cToolTip =  { "Show RGB","RGB", 1, CLR_BLACK, 14089979 }
oRGBBtn[3]:SetColor( 0, )

@ 175, 290  BTNBMP oRGBBtn[4] OF oFld1:aDialogs[ 4 ] ;
SIZE 55, 22 PIXEL 2007 ; 
NOBORDER ;
PROMPT " &Show RGB" ;
FILENAME c_path1 + "Paint.Bmp" ;
ACTION SHOW_RGB(oFld1, 4) ;
LEFT
oRGBBtn[4]:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oRGBBtn[4]:lTransparent := .t.   
oRGBBtn[4]:cToolTip =  { "Show RGB","RGB", 1, CLR_BLACK, 14089979 }
oRGBBtn[4]:SetColor( 0, )

@ 175, 290  BTNBMP oRGBBtn[5] OF oFld1:aDialogs[ 5 ] ;
SIZE 55, 22 PIXEL 2007 ; 
NOBORDER ;
PROMPT " &Show RGB" ;
FILENAME c_path1 + "Paint.Bmp" ;
ACTION SHOW_RGB(oFld1, 5) ;
LEFT
oRGBBtn[5]:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oRGBBtn[5]:lTransparent := .t.   
oRGBBtn[5]:cToolTip =  { "Show RGB","RGB", 1, CLR_BLACK, 14089979 }
oRGBBtn[5]:SetColor( 0, )

F_PAGE1( oFld1 )
F_PAGE2( oFld1 )
F_PAGE3( oFld1 )
F_PAGE4( oFld1 )
F_PAGE5( oFld1 )

@ 240, 10 BITMAP oGrd[1] FILENAME NIL OF oDlg1 ;
SIZE 38, 30 PIXEL BORDER UPDATE
oGrd[1]:bPainted := { |hDC| IIF( l1_Grad = .T., DRAW_BMP( oGrd[1], hDC, 3, n1_GradC1, n1_GradC2, l1_GradDir, n1_Gradpos ), ;
                                                                                     DRAW_BMP( oGrd[1], hDC, 1, n1_GradC1, n1_GradC1, l1_GradDir, n1_Gradpos ) ) }

@ 240, 50 BITMAP oGrd[2] FILENAME NIL OF oDlg1 ;
SIZE 38, 30 PIXEL BORDER UPDATE
oGrd[2]:bPainted := { |hDC| IIF( l1_Grad = .T., DRAW_BMP( oGrd[2], hDC, 3, n2_GradC1, n2_GradC2, l2_GradDir, n2_Gradpos ), ;
                                                                                     DRAW_BMP( oGrd[2], hDC, 1, n2_GradC1, n2_GradC1, l2_GradDir, n2_Gradpos ) ) }

@ 240, 90 BITMAP oGrd[3] FILENAME NIL OF oDlg1 ;
SIZE 38, 30 PIXEL BORDER UPDATE
oGrd[3]:bPainted := { |hDC| IIF( l1_Grad = .T., DRAW_BMP( oGrd[3], hDC, 3, n3_GradC1, n3_GradC2, l3_GradDir, n3_Gradpos ), ;
                                                                                     DRAW_BMP( oGrd[3], hDC, 1, n3_GradC1, n3_GradC1, l3_GradDir, n3_Gradpos ) ) }

@ 240, 130 BITMAP oGrd[4] FILENAME NIL OF oDlg1 ;
SIZE 38, 30 PIXEL BORDER UPDATE
oGrd[4]:bPainted := { |hDC| IIF( l1_Grad = .T., DRAW_BMP( oGrd[4], hDC, 3, n4_GradC1, n4_GradC2, l4_GradDir, n4_Gradpos ), ;
                                                                                     DRAW_BMP( oGrd[4], hDC, 1, n4_GradC1, n4_GradC1, l4_GradDir, n4_Gradpos ) ) }

@ 240, 170 BITMAP oGrd[5] FILENAME NIL OF oDlg1 ;
SIZE 38, 30 PIXEL BORDER UPDATE
oGrd[5]:bPainted := { |hDC| IIF( l1_Grad = .T., DRAW_BMP( oGrd[5], hDC, 3, n5_GradC1, n5_GradC2, l5_GradDir, n5_Gradpos ), ;
																					 DRAW_BMP( oGrd[5], hDC, 1, n5_GradC1, n5_GradC1, l5_GradDir, n5_Gradpos ) ) }

@ 240, 210  BTNBMP oFBtn1 OF oDlg1 ;
SIZE 55, 30 PIXEL 2007 ; 
NOBORDER ;
PROMPT " &Load from" + CRLF + " Project" ;
FILENAME c_path1 + "Minus.Bmp" ;
ACTION ( LOAD_PROJECT( oDlg1 ), ;
                  FLD_GRAD( oFld1 ), ;
                  oFld1:SetOption(1), oFld1:aDialogs[1]:Refresh(), oDlg1:Refresh() ) ;
FONT oFont1 ;
LEFT
oFBtn1:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oFBtn1:lTransparent := .t.   
oFBtn1:cToolTip =  { "SKIP" + CRLF + "previous","SKIP", 1, CLR_BLACK, 14089979 }
oFBtn1:SetColor( 0, )

@ 240, 270  BTNBMP oFBtn2 OF oDlg1 ;
SIZE 20, 30 PIXEL 2007 ; 
NOBORDER ;
PROMPT "" ;
FILENAME c_path1 + "Minus.Bmp" ;
ACTION (  DBSELECTAREA("SET"), DBSKIP(-1), LOAD_DBF(oDlg1, .T.), FLD_GRAD( oFld1 ), ;
                    oFld1:SetOption(1), oFld1:aDialogs[1]:Refresh(), oDlg1:Refresh() ) ;
LEFT
oFBtn2:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oFBtn2:lTransparent := .t.   
oFBtn2:cToolTip =  { "SKIP" + CRLF + "previous","SKIP", 1, CLR_BLACK, 14089979 }
oFBtn2:SetColor( 0, )

@ 240, 295  BTNBMP oFBtn3 OF oDlg1 ;
SIZE 20, 30 PIXEL 2007 ; 
NOBORDER ;
PROMPT "" ;
FILENAME c_path1 + "Plus.Bmp" ;
ACTION (  DBSELECTAREA("SET"), DBSKIP(+1), LOAD_DBF(oDlg1, .T.), FLD_GRAD( oFld1 ), ;
                    oFld1:SetOption(1), oFld1:aDialogs[1]:Refresh(), oDlg1:Refresh() ) ;
LEFT
oFBtn3:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 11513775, 16777215 }, ;
		{ 0.50, 16777215, 11513775 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oFBtn3:lTransparent := .t.   
oFBtn3:cToolTip =  { "SKIP" + CRLF + "next","SKIP", 1, CLR_BLACK, 14089979 }
oFBtn3:SetColor( 0, )

@ 240, 320 BTNBMP oFBtn4 OF oDlg1 ;
SIZE 50, 30 PIXEL 2007 ; 
NOBORDER ;
PROMPT "&Exit Folder" ;
FILENAME c_path1 + "Exit.Bmp" ;
ACTION oDlg1:End() ;
FONT oFont1 ;
LEFT
oFBtn4:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 6711039, 16777215 }, ;
		{ 0.50, 16777215, 6711039 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oFBtn4:lTransparent := .t.   
oFBtn4:cToolTip =  { "Exit" + CRLF + "Settings","EXIT", 1, CLR_BLACK, 14089979 }
oFBtn4:SetColor( 0, )

ACTIVATE DIALOG oDlg1 CENTER ;
ON INIT ( WD_BACKGRD( oDlg1, oDlg1:nWidth(), oDlg1:nHeight(), 3, nDColorF, nDColorB, nDGradpos, lDDirect, "Marble.bmp" ), ;
                  FLD_GRAD( oFld1 ) )

oFont:End()
oFont1:End()
oFont2:End()
oFont3:End()

RETURN NIL

// --------------------------

FUNCTION F_PAGE1( oFld1 )
LOCAL oGet, oCheck, oRadio, nRadio := 1, lCheck := .T., oImage, oBtn1
LOCAL oCombo, cCombo := "  Line 1"
LOCAL aBitmaps := { c_path1 + "Alert.Bmp",;
                                        c_path1 + "Alert.bmp",;
                                        c_path1 + "Alert.bmp" }

@ 25, 130 CHECKBOX oCheck VAR lCheck PROMPT "&Checkbox" ;
SIZE 50, 20 OF oFld1:aDialogs[ 1 ] PIXEL UPDATE ;
ON CHANGE MsgBeep()
oCheck:SetColor( 0, )
oCheck:SetFont( oFont3 )
oCheck:lTransparent := .T.

@ 30, 60 RADIO oRadio VAR nRadio OF oFld1:aDialogs[ 1 ] ;
ITEMS "&One", "&Two", "T&hree" _3D SIZE 50, 12 PIXEL UPDATE ;
HELPID 100, 101, 102 ;
ON CHANGE MsgBeep()
AEval( oRadio:aItems, { | oRad | oRad:lTransparent := .T., ;
						     oRad:SetFont ( oFont3 ), ;
                             oRad:nClrText := 0 } )

@ 80, 65 COMBOBOX oCombo VAR cCombo OF oFld1:aDialogs[ 1 ] PIXEL UPDATE ;
ITEMS { "  Line 1", "  Line 2", "  Line 3" } ;
SIZE 50, 60 BITMAPS aBitmaps ; // Width, Height
ON CHANGE MsgBeep()
oCombo:SetColor( 0, 16777215 )
oCombo:SetFont( oFont1 )

@ 130, 65 SAY oSay PROMPT "Transparent Text-test"  OF oFld1:aDialogs[ 1 ] PIXEL UPDATE ;
FONT oFont3 SIZE 95, 12 COLOR 0
oSay:lTransparent := .T.

@ 20, 180 IMAGE oImage SIZE 200, 200  FILENAME NIL OF oFld1:aDialogs[ 1 ] PIXEL NOBORDER UPDATE
oImage:bPainted := { |hDC| DRAW_BMP( oImage, hDC, 4, , , , , "Logo.bmp" ) }

@ 180, 30 GET oGet VAR c1_GradArr OF oFld1:aDialogs[ 1 ] SIZE 250, 12 PIXEL FONT oFont2 UPDATE
oGet:SetColor( 255, 16777215 )

RETURN NIL

// ---------------

FUNCTION SHOW_RGB(oFld1, nPos)
LOCAL oDlg3, oGet, oBtn1, cRGBGrad := "", cTextRGB1 := "", cTextRGB2 := ""
LOCAL nRed1, nRed2, nGreen1, nGreen2, nBlue1, nBlue2, lGrad := .T., nGradPos := 1

DEFINE DIALOG oDlg3 TITLE "RGB-translation" SIZE 550, 160 PIXEL FONT  oFont  OF oFld1 

IF nPos = 1
		nRed1 := nRGBRed( n1_GradC1 )
		nGreen1 := nRGBGreen( n1_GradC1 )
		nBlue1 := nRGBBlue( n1_GradC1 )

		nRed2 := nRGBRed( n1_GradC2 )
		nGreen2 := nRGBGreen( n1_GradC2 )
		nBlue2 := nRGBBlue( n1_GradC2 )

        lGrad := l1_Grad
        nGradPos := n1_Gradpos
ENDIF
IF nPos = 2
		nRed1 := nRGBRed( n2_GradC1 )
		nGreen1 := nRGBGreen( n2_GradC1 )
		nBlue1 := nRGBBlue( n2_GradC1 )

		nRed2 := nRGBRed( n2_GradC2 )
		nGreen2 := nRGBGreen( n2_GradC2 )
		nBlue2 := nRGBBlue( n2_GradC2 )

        lGrad := l2_Grad
        nGradPos := n2_Gradpos
ENDIF
IF nPos = 3
		nRed1 := nRGBRed( n3_GradC1 )
		nGreen1 := nRGBGreen( n3_GradC1 )
		nBlue1 := nRGBBlue( n3_GradC1 )

		nRed2 := nRGBRed( n3_GradC2 )
		nGreen2 := nRGBGreen( n3_GradC2 )
		nBlue2 := nRGBBlue( n3_GradC2 )

        lGrad := l3_Grad
        nGradPos := n3_Gradpos
ENDIF
IF nPos = 4
		nRed1 := nRGBRed( n4_GradC1 )
		nGreen1 := nRGBGreen( n4_GradC1 )
		nBlue1 := nRGBBlue( n4_GradC1 )

		nRed2 := nRGBRed( n4_GradC2 )
		nGreen2 := nRGBGreen( n4_GradC2 )
		nBlue2 := nRGBBlue( n4_GradC2 )

        lGrad := l4_Grad
        nGradPos := n4_Gradpos
ENDIF
IF nPos = 5
		nRed1 := nRGBRed( n5_GradC1 )
		nGreen1 := nRGBGreen( n5_GradC1 )
		nBlue1 := nRGBBlue( n5_GradC1 )

		nRed2 := nRGBRed( n5_GradC2 )
		nGreen2 := nRGBGreen( n5_GradC2 )
		nBlue2 := nRGBBlue( n5_GradC2 )

        lGrad := l5_Grad
        nGradPos := n5_Gradpos
ENDIF

cTextRGB1 := "nRGB( " + ALLTRIM(STR(nRed1)) + ", " + ;
												  ALLTRIM(STR(nGreen1)) + ", " + ;
												  ALLTRIM(STR(nBlue1)) + " )"
cTextRGB2 := "nRGB( " + ALLTRIM(STR(nRed2)) + ", " + ;
												  ALLTRIM(STR(nGreen2)) + ", " + ;
												  ALLTRIM(STR(nBlue2)) + " )"
		
IF lGrad = .T.
		cRGBGrad := "aGrad := { { " + ALLTRIM(STR( nGradpos )) + ", " + cTextRGB1 + ", " + cTextRGB2 + " }, ;" + CRLF + ;
															SPACE( 17.5 ) + "{ " + ALLTRIM(STR( nGradpos )) + ", " + cTextRGB2 + ", " + cTextRGB1 + " } }"
ELSE
		cRGBGrad := "nColor := " + cTextRGB1
ENDIF

@ 10, 10 GET oGet VAR cRGBGrad OF oDlg3 MULTILINE SIZE 250, 25 PIXEL FONT oFont2 UPDATE
oGet:SetColor( 0, 16777215 )

@ 50, 210 BTNBMP oBtn1 OF oDlg3 ;
SIZE 50, 25 PIXEL 2007 ; 
NOBORDER ;
PROMPT "&Exit " ;
FILENAME c_path1 + "Exit.Bmp" ;
ACTION oDlg3:End() ;
FONT oFont1 ;
LEFT
oBtn1:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
		{ { 0.50, 6711039, 16777215 }, ;
		{ 0.50, 16777215, 6711039 } }, ;
		{ { 0.50, 16761992, 16777215 }, ;
		{ 0.50, 16777215, 16761992 } } ) }
oBtn1:lTransparent := .t.   
oBtn1:cToolTip =  { "Exit" + CRLF + "Settings","EXIT", 1, CLR_BLACK, 14089979 }
oBtn1:SetColor( 0, )

ACTIVATE DIALOG oDlg3 CENTER ;
ON INIT  WD_BACKGRD( oDlg3, oDlg3:nWidth(), oDlg3:nHeight(), 3, nDColorF, nDColorB, nDGradpos, lDDirect, "Marble.bmp" )

RETURN NIL

// --------------------------

FUNCTION F_PAGE2( oFld1 )
LOCAL oGet, oCheck, oRadio, nRadio := 1, lCheck := .T., oImage, oBtn1
LOCAL oCombo, cCombo := "  Line 1"
LOCAL aBitmaps := { c_path1 + "Alert.Bmp",;
                                        c_path1 + "Alert.bmp",;
                                        c_path1 + "Alert.bmp" }

@ 25, 130 CHECKBOX oCheck VAR lCheck PROMPT "&Checkbox" ;
SIZE 50, 20 OF oFld1:aDialogs[ 2 ] PIXEL UPDATE ;
ON CHANGE MsgBeep()
oCheck:SetColor( 0, )
oCheck:SetFont( oFont3 )
oCheck:lTransparent := .T.

@ 30, 60 RADIO oRadio VAR nRadio OF oFld1:aDialogs[ 2 ] ;
ITEMS "&One", "&Two", "T&hree" _3D SIZE 50, 12 PIXEL UPDATE ;
HELPID 100, 101, 102 ;
ON CHANGE MsgBeep()
AEval( oRadio:aItems, { | oRad | oRad:lTransparent := .T., ;
						     oRad:SetFont ( oFont3 ), ;
                             oRad:nClrText := 0 } )

@ 80, 65 COMBOBOX oCombo VAR cCombo OF oFld1:aDialogs[ 2 ] PIXEL UPDATE ;
ITEMS { "  Line 1", "  Line 2", "  Line 3" } ;
SIZE 50, 60 BITMAPS aBitmaps ; // Width, Height
ON CHANGE MsgBeep()
oCombo:SetColor( 0, 16777215 )
oCombo:SetFont( oFont1 )

@ 130, 65 SAY oSay PROMPT "Transparent Text-test"  OF oFld1:aDialogs[ 2 ] PIXEL UPDATE ;
FONT oFont3 SIZE 95, 12 COLOR 0
oSay:lTransparent := .T.

@ 20, 180 IMAGE oImage SIZE 200, 200  FILENAME NIL OF oFld1:aDialogs[ 2 ] PIXEL NOBORDER UPDATE
oImage:bPainted := { |hDC| DRAW_BMP( oImage, hDC, 4, , , , , "Logo.bmp" ) }

@ 180, 30 GET oGet VAR c1_GradArr OF oFld1:aDialogs[ 2 ] SIZE 250, 12 PIXEL FONT oFont2 UPDATE
oGet:SetColor( 255, 16777215 )

RETURN NIL

// --------------------------

FUNCTION F_PAGE3( oFld1 )
LOCAL oGet, oCheck, oRadio, nRadio := 1, lCheck := .T., oImage, oBtn1
LOCAL oCombo, cCombo := "  Line 1"
LOCAL aBitmaps := { c_path1 + "Alert.Bmp",;
                                        c_path1 + "Alert.bmp",;
                                        c_path1 + "Alert.bmp" }

@ 25, 130 CHECKBOX oCheck VAR lCheck PROMPT "&Checkbox" ;
SIZE 50, 20 OF oFld1:aDialogs[ 3 ] PIXEL UPDATE ;
ON CHANGE MsgBeep()
oCheck:SetColor( 0, )
oCheck:SetFont( oFont3 )
oCheck:lTransparent := .T.

@ 30, 60 RADIO oRadio VAR nRadio OF oFld1:aDialogs[ 3 ] ;
ITEMS "&One", "&Two", "T&hree" _3D SIZE 50, 12 PIXEL UPDATE ;
HELPID 100, 101, 102 ;
ON CHANGE MsgBeep()
AEval( oRadio:aItems, { | oRad | oRad:lTransparent := .T., ;
						     oRad:SetFont ( oFont3 ), ;
                             oRad:nClrText := 0 } )

@ 80, 65 COMBOBOX oCombo VAR cCombo OF oFld1:aDialogs[ 3 ] PIXEL UPDATE ;
ITEMS { "  Line 1", "  Line 2", "  Line 3" } ;
SIZE 50, 60 BITMAPS aBitmaps ; // Width, Height
ON CHANGE MsgBeep()
oCombo:SetColor( 0, 16777215 )
oCombo:SetFont( oFont1 )

@ 130, 65 SAY oSay PROMPT "Transparent Text-test"  OF oFld1:aDialogs[ 3 ] PIXEL UPDATE ;
FONT oFont3 SIZE 95, 12 COLOR 0
oSay:lTransparent := .T.

@ 20, 180 IMAGE oImage SIZE 200, 200  FILENAME NIL OF oFld1:aDialogs[ 3 ] PIXEL NOBORDER UPDATE
oImage:bPainted := { |hDC| DRAW_BMP( oImage, hDC, 4, , , , , "Logo.bmp" ) }

@ 180, 30 GET oGet VAR c1_GradArr OF oFld1:aDialogs[ 3 ] SIZE 250, 12 PIXEL FONT oFont2 UPDATE
oGet:SetColor( 255, 16777215 )

RETURN NIL

// --------------------------

FUNCTION F_PAGE4( oFld1 )
LOCAL oGet, oCheck, oRadio, nRadio := 1, lCheck := .T., oImage, oBtn1
LOCAL oCombo, cCombo := "  Line 1"
LOCAL aBitmaps := { c_path1 + "Alert.Bmp",;
                                        c_path1 + "Alert.bmp",;
                                        c_path1 + "Alert.bmp" }

@ 25, 130 CHECKBOX oCheck VAR lCheck PROMPT "&Checkbox" ;
SIZE 50, 20 OF oFld1:aDialogs[ 4 ] PIXEL UPDATE ;
ON CHANGE MsgBeep()
oCheck:SetColor( 0, )
oCheck:SetFont( oFont3 )
oCheck:lTransparent := .T.

@ 30, 60 RADIO oRadio VAR nRadio OF oFld1:aDialogs[ 4 ] ;
ITEMS "&One", "&Two", "T&hree" _3D SIZE 50, 12 PIXEL UPDATE ;
HELPID 100, 101, 102 ;
ON CHANGE MsgBeep()
AEval( oRadio:aItems, { | oRad | oRad:lTransparent := .T., ;
						     oRad:SetFont ( oFont3 ), ;
                             oRad:nClrText := 0 } )

@ 80, 65 COMBOBOX oCombo VAR cCombo OF oFld1:aDialogs[ 4 ] PIXEL UPDATE ;
ITEMS { "  Line 1", "  Line 2", "  Line 3" } ;
SIZE 50, 60 BITMAPS aBitmaps ; // Width, Height
ON CHANGE MsgBeep()
oCombo:SetColor( 0, 16777215 )
oCombo:SetFont( oFont1 )

@ 130, 65 SAY oSay PROMPT "Transparent Text-test"  OF oFld1:aDialogs[ 4 ] PIXEL UPDATE ;
FONT oFont3 SIZE 95, 12 COLOR 0
oSay:lTransparent := .T.

@ 20, 180 IMAGE oImage SIZE 200, 200  FILENAME NIL OF oFld1:aDialogs[ 4 ] PIXEL NOBORDER UPDATE
oImage:bPainted := { |hDC| DRAW_BMP( oImage, hDC, 4, , , , , "Logo.bmp" ) }

@ 180, 30 GET oGet VAR c1_GradArr OF oFld1:aDialogs[ 4 ] SIZE 250, 12 PIXEL FONT oFont2 UPDATE
oGet:SetColor( 255, 16777215 )

RETURN NIL

// --------------------------

FUNCTION F_PAGE5( oFld1 )
LOCAL oGet, oCheck, oRadio, nRadio := 1, lCheck := .T., oImage, oBtn1
LOCAL oCombo, cCombo := "  Line 1"
LOCAL aBitmaps := { c_path1 + "Alert.Bmp",;
                                        c_path1 + "Alert.bmp",;
                                        c_path1 + "Alert.bmp" }

@ 25, 130 CHECKBOX oCheck VAR lCheck PROMPT "&Checkbox" ;
SIZE 50, 20 OF oFld1:aDialogs[ 5 ] PIXEL UPDATE ;
ON CHANGE MsgBeep()
oCheck:SetColor( 0, )
oCheck:SetFont( oFont3 )
oCheck:lTransparent := .T.

@ 30, 60 RADIO oRadio VAR nRadio OF oFld1:aDialogs[ 5 ] ;
ITEMS "&One", "&Two", "T&hree" _3D SIZE 50, 12 PIXEL UPDATE ;
HELPID 100, 101, 102 ;
ON CHANGE MsgBeep()
AEval( oRadio:aItems, { | oRad | oRad:lTransparent := .T., ;
						     oRad:SetFont ( oFont3 ), ;
                             oRad:nClrText := 0 } )

@ 80, 65 COMBOBOX oCombo VAR cCombo OF oFld1:aDialogs[ 5 ] PIXEL UPDATE ;
ITEMS { "  Line 1", "  Line 2", "  Line 3" } ;
SIZE 50, 60 BITMAPS aBitmaps ; // Width, Height
ON CHANGE MsgBeep()
oCombo:SetColor( 0, 16777215 )
oCombo:SetFont( oFont1 )

@ 130, 65 SAY oSay PROMPT "Transparent Text-test"  OF oFld1:aDialogs[ 5 ] PIXEL UPDATE ;
FONT oFont3 SIZE 95, 12 COLOR 0
oSay:lTransparent := .T.

@ 20, 180 IMAGE oImage SIZE 200, 200  FILENAME NIL OF oFld1:aDialogs[ 5 ] PIXEL NOBORDER UPDATE
oImage:bPainted := { |hDC| DRAW_BMP( oImage, hDC, 4, , , , , "Logo.bmp" ) }

@ 180, 30 GET oGet VAR c1_GradArr OF oFld1:aDialogs[ 5 ] SIZE 250, 12 PIXEL FONT oFont2 UPDATE
oGet:SetColor( 255, 16777215 )

RETURN NIL

// ---------------------

FUNCTION PaintTab( o, nOption )

IF nOption == o:nOver .OR. nOption == o:nOption
		o:SetAlphaLevel( nOption, 255 )
ELSE 
		o:SetAlphaLevel( nOption, 50 )
ENDIF 
   
RETURN o:SetFldColors( o, nOption )    

// --------  FOLDER - Backgrounds ---------------

FUNCTION FLD_GRAD( oFld1 ) 
LOCAL n, oDlg, hDC, oBrush, hBmp, hBmpOld, aGrad := {}, lDirect

FOR n := 1 to Len( oFld1:aDialogs ) 
		oDlg := oFld1:aDialogs[ n ]
		hDC = CreateCompatibleDC( oDlg:GetDC() )
		hBmp = CreateCompatibleBitMap( oDlg:hDC, oDlg:nWidth, oDlg:nHeight )
		hBmpOld = SelectObject( hDC, hBmp )
		IF n = 1
                IF l1_Grad = .T.
						aGrad := { { n1_Gradpos, n1_GradC1, n1_GradC2 }, { n1_Gradpos, n1_GradC2, n1_GradC1 } }
				ELSE
						aGrad := { { n1_Gradpos, n1_GradC1, n1_GradC1 }, { n1_Gradpos, n1_GradC1, n1_GradC1 } }
		                c1_GradArr := "nColor := " + ALLTRIM(STR(	n1_GradC1 ))	
				ENDIF
				lDirect := l1_GradDir
		ENDIF
		IF n = 2
                IF l1_Grad = .T.
						aGrad := { { n2_Gradpos, n2_GradC1, n2_GradC2 }, { n2_Gradpos, n2_GradC2, n2_GradC1 } }
				ELSE
						aGrad := { { n2_Gradpos, n2_GradC1, n2_GradC1 }, { n2_Gradpos, n2_GradC1, n2_GradC1 } }
					    c2_GradArr := "nColor := " + ALLTRIM(STR(	n2_GradC1 ))	
				ENDIF
				lDirect := l2_GradDir
		ENDIF
		IF n = 3
                IF l1_Grad = .T.
						aGrad := { { n3_Gradpos, n3_GradC1, n3_GradC2 }, { n3_Gradpos, n3_GradC2, n3_GradC1 } }
				ELSE
						aGrad := { { n3_Gradpos, n3_GradC1, n3_GradC1 }, { n3_Gradpos, n3_GradC1, n3_GradC1 } }
			            c3_GradArr := "nColor := " + ALLTRIM(STR(	n3_GradC1 ))	
				ENDIF
				lDirect := l3_GradDir
		ENDIF
		IF n = 4
                IF l1_Grad = .T.
						aGrad := { { n4_Gradpos, n4_GradC1, n4_GradC2 }, { n4_Gradpos, n4_GradC2, n4_GradC1 } }
				ELSE
						aGrad := { { n4_Gradpos, n4_GradC1, n4_GradC1 }, { n4_Gradpos, n4_GradC1, n4_GradC1 } }
		                c4_GradArr := "nColor := " + ALLTRIM(STR(	n4_GradC1 ))	
				ENDIF
				lDirect := l4_GradDir
		ENDIF
		IF n = 5
                IF l1_Grad = .T.
						aGrad := { { n5_Gradpos, n5_GradC1, n5_GradC2 }, { n5_Gradpos, n5_GradC2, n5_GradC1 } }
				ELSE
						aGrad := { { n5_Gradpos, n5_GradC1, n5_GradC1 }, { n5_Gradpos, n5_GradC1, n5_GradC1 } }
		                c5_GradArr := "nColor := " + ALLTRIM(STR(	n5_GradC1 ))	
				ENDIF
				lDirect := l5_GradDir
		ENDIF
        GRADIENTFILL( hDC, 0, 0, oDlg:nHeight, oDlg:nWidth, aGrad, lDirect )
		oDlg:oBrush = TBrush():New()
		oDlg:oBrush:hBitmap = hBmp
		oDlg:oBrush:hBrush = CreatePatternBrush( hBmp )
		SelectObject( hDC, hBmpOld )
		oDlg:ReleaseDC()
        oDlg:Update()
		AEVAL( oDlg:aControls, { | oCtl | If( oCtl:lTransparent, oCtl:SetBrush( oDlg:oBrush ), ) } )
NEXT

RETURN( NIL )

// --------------------

FUNCTION LOAD_PROJECT( oDlg1 ) 
LOCAL oDlg3, oData, oStru, oBrush, oBar1, oBtn1, oBtn2, oBtn3, oBtn4, oBtn5, oBtn6
LOCAL oGet1, oGet2, oSelex1, nKeepline := 1, nStrucRow := 1, oSeek, oGrd[6]

lNewproj := .F.

DEFINE DIALOG oDlg3 SIZE 700, 390 ;
TITLE "PROJECT - selection"  OF oDlg1 FONT oFont

DBSELECTAREA("SET") 
LOAD_DBF(oDlg3)

@ 10,10 XBROWSE oData  SIZE 330, 108  OF oDlg3 PIXEL AUTOSORT ;
DATASOURCE "SET" COLUMNS "cPROJECT", "LSELECTED" ;
ON CHANGE ( LOAD_DBF(oDlg), oDlg3:Update() )

oData:nMarqueeStyle			:=  MARQSTYLE_HIGHLROW
oData:nColDividerStyle		:= LINESTYLE_BLACK
oData:nRowDividerStyle		:= LINESTYLE_BLACK
oData:lHScroll							:= .F.
oData:lVScroll							:= .T.
oData:lFooter							:= .T.
oData:nHeaderHeight			:= 30
oData:nFooterHeight			:= 30
oData:nRowHeight				:= 25
oData:oFont							:= oFont1

oCol := oData:AddCol()
oData:aCols[ 1 ]:cHeader			:= "P R O J E C T"
oData:aCols[ 1 ]:addbmpfile( c_path1 + "Info.bmp" ) // from Disk
oData:aCols[ 1 ]:nFootBmpNo	:= 1 // Footer BMP
oData:aCols[ 1 ]:nWidth				:= 170
oData:aCols[ 1 ]:bEditValue		:= { || ("SET")->cPROJECT }

oCol := oData:AddCol()
oData:aCols[ 2 ]:cHeader		:= "START"
oData:aCols[ 2 ]:nHeadStrAlign	:= AL_CENTER
oData:aCols[ 2 ]:addbmpfile( c_path1 + "Checkon.bmp" ) // from Disk
oData:aCols[ 2 ]:addbmpfile( c_path1 + "Checkoff.bmp" ) // from Disk
oData:aCols[ 2 ]:addbmpfile( c_path1 + "Info.bmp" ) // from Disk
oData:aCols[ 2 ]:bBmpData	:= {|| IIF( ("SET")->LSELECTED = .T., 1, 2 ) }
oData:aCols[ 2 ]:bAlphaLevel := { || IF( ("SET")->( DELETED() ) , 60, 255 ) }
oData:aCols[ 2 ]:bEditValue	:= { || NIL }
oData:aCols[ 2 ]:nFootBmpNo	:= 3 // Footer BMP
oData:aCols[ 2 ]:nWidth			:= 52
oData:aCols[ 2 ]:bToolTip		:= {| oData, nRow, nCol, nKeyFlag | ;
										IF( oData:MouseRowPos(nRow) == oData:nRowSel, ;
											"PROJECT-START" + CRLF + ;
											+ CRLF + ;
											"switch < Y / N > " + CRLF + ;
											"with right" + CRLF + ;
											"mouseclick", ) }

oCol := oData:AddCol()
oData:aCols[ 3 ]:cHeader		:= "Numeric"
oData:aCols[ 3 ]:nHeadStrAlign	:= AL_CENTER
oData:aCols[ 3 ]:nDataStrAlign	:= AL_RIGHT
oData:aCols[ 3 ]:bStrData		:= { || ("SET")->nValRGB }
oData:aCols[ 3 ]:nWidth			:= 70

oCol := oData:AddCol()
oData:aCols[ 4 ]:cHeader		:= "RGB"
oData:aCols[ 4 ]:nHeadStrAlign	:= AL_CENTER
oData:aCols[ 4 ]:nDataStrAlign	:= AL_CENTER
oData:aCols[ 4 ]:bEditValue	:= { || ("SET")->cTextRGB }
oData:aCols[ 4 ]:nWidth			:= 140

oCol := oData:AddCol()
oData:aCols[ 5 ]:cHeader		:= "Word"
oData:aCols[ 5 ]:nHeadStrAlign	:= AL_CENTER
oData:aCols[ 5 ]:nDataStrAlign	:= AL_CENTER
oData:aCols[ 5 ]:bEditValue	:= { || ("SET")->cWordRGB }
oData:aCols[ 5 ]:nWidth			:= 120
 
oCol := oData:AddCol()
oData:aCols[ 6 ]:cHeader		:= "Bright"
oData:aCols[ 6 ]:nHeadStrAlign	:= AL_CENTER
oData:aCols[ 6 ]:nDataStrAlign	:= AL_CENTER
oData:aCols[ 6 ]:bEditValue	:= { || ("SET")->nBrightRGB }
oData:aCols[ 6 ]:nWidth			:= 50

oData:bRClicked := { || ( nRPos := oData:KeyNo(), ;
											  nCPos := oData:SelectedCol():nCreationOrder, ;
											  CLEAR_SEL(oData) ) }

WITH OBJECT oData
        :lIncrFilter := .T.
		:bClrStd := { || If( oData:KeyNo() % 2 == 0, ;
								{ If( ( oData:cAlias )->( Deleted() ), 255, 0 ), 16772313 }, ;
								{ If( ( oData:cAlias )->( Deleted() ), 255, 0 ), 16766378 } ) }
		:lColChangeNotify	:= .T.
		:bChange				:= { || LOAD_DBF(oDlg3), ;
												 oGrd[1]:Refresh(), oGrd[2]:Refresh(), oGrd[3]:Refresh(), ;
												 oGrd[4]:Refresh(), oGrd[5]:Refresh(), oGrd[6]:Refresh() }
		:CreateFromCode()
END

@ 120, 10 BITMAP oGrd[1] FILENAME NIL OF oDlg3 ;
SIZE 30, 30 PIXEL BORDER UPDATE
oGrd[1]:bPainted := { |hDC| DRAW_BMP( oGrd[1], hDC, 1, nValRGB ) }

@ 120, 70 BITMAP oGrd[2] FILENAME NIL OF oDlg3 ;
SIZE 50, 30 PIXEL BORDER UPDATE
oGrd[2]:bPainted := { |hDC| IIF( l1_Grad = .T., DRAW_BMP( oGrd[2], hDC, 3, n1_GradC1, n1_GradC2, l1_GradDir, n1_Gradpos ), ;
                                                                                     DRAW_BMP( oGrd[2], hDC, 1, n1_GradC1, n1_GradC1, l1_GradDir, n1_Gradpos ) ) }

@ 120, 125 BITMAP oGrd[3] FILENAME NIL OF oDlg3 ;
SIZE 50, 30 PIXEL BORDER UPDATE
oGrd[3]:bPainted := { |hDC| IIF( l1_Grad = .T., DRAW_BMP( oGrd[3], hDC, 3, n2_GradC1, n2_GradC2, l2_GradDir, n2_Gradpos ), ;
                                                                                     DRAW_BMP( oGrd[3], hDC, 1, n2_GradC1, n2_GradC1, l2_GradDir, n2_Gradpos ) ) }
@ 120, 180 BITMAP oGrd[4] FILENAME NIL OF oDlg3 ;
SIZE 50, 30 PIXEL BORDER UPDATE
oGrd[4]:bPainted := { |hDC| IIF( l1_Grad = .T., DRAW_BMP( oGrd[4], hDC, 3, n3_GradC1, n3_GradC2, l3_GradDir, n3_Gradpos ), ;
                                                                                     DRAW_BMP( oGrd[4], hDC, 1, n3_GradC1, n3_GradC1, l3_GradDir, n3_Gradpos ) ) }
@ 120, 235 BITMAP oGrd[5] FILENAME NIL OF oDlg3 ;
SIZE 50, 30 PIXEL BORDER UPDATE
oGrd[5]:bPainted := { |hDC| IIF( l1_Grad = .T., DRAW_BMP( oGrd[5], hDC, 3, n4_GradC1, n4_GradC2, l4_GradDir, n4_Gradpos ), ;
                                                                                     DRAW_BMP( oGrd[5], hDC, 1, n4_GradC1, n4_GradC1, l4_GradDir, n4_Gradpos ) ) }
@ 120, 290 BITMAP oGrd[6] FILENAME NIL OF oDlg3 ;
SIZE 50, 30 PIXEL BORDER UPDATE
oGrd[6]:bPainted := { |hDC| IIF( l1_Grad = .T., DRAW_BMP( oGrd[6], hDC, 3, n5_GradC1, n5_GradC2, l5_GradDir, n5_Gradpos ), ;
                                                                                     DRAW_BMP( oGrd[6], hDC, 1, n5_GradC1, n5_GradC1, l5_GradDir, n5_Gradpos ) ) }

@ 155, 115 SAY oSeek PROMPT "Seek project" SIZE 70, 12 OF oDlg3 PIXEL FONT oFont1		  
oSeek:Setcolor( nDTxtColor,  )
oSeek:lTransparent := .T.

@ 165, 115 SAY oData:oSeek PROMPT oData:cSeek SIZE 70, 12 OF oDlg3 PIXEL FONT oFont1		  
oData:oSeek:Setcolor( 255, 16772313  )

@ 165, 210 BTNBMP oBtn3 OF oDlg3 ;
SIZE 55, 22 PIXEL 2007 ;
ROUND NOBORDER ;
PROMPT " &Select    " ;
FILENAME c_path1 + "Select.Bmp" ;
ACTION ( lNewProj := .T., ;
				  cBrwPos := ("SET")->cPROJECT, ;
				  nBrwPos := oData:KeyNo(), ; 
                  LOAD_DBF(oDlg3), ;
                  oDlg3:End() ) ;
FONT oFont1 ;
LEFT
oBtn3:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
	{ { 0.50, 3067734, 16777215 }, ;
	{ 0.50, 16777215, 3067734 } }, ;
	{ { 0.50, 3145727, 16777215 }, ;
	{ 0.50, 16777215, 3145727 } } ) }
oBtn3:lTransparent := .t.   
oBtn3:cToolTip =  { "Select" + CRLF + "Project","SELECT", 1, CLR_BLACK, 14089979 }
oBtn3:SetColor( 0, )

@ 165, 285 BTNBMP oBtn4 OF oDlg3 ;
SIZE 55, 22 PIXEL 2007 ;
ROUND NOBORDER ;
PROMPT " &Exit    " ;
FILENAME c_path1 + "Exit.Bmp" ;
ACTION oDlg3:End() ;
FONT oFont1 ;
LEFT
oBtn4:bClrGrad = { | lMouseOver | If( ! lMouseOver,;
	{ { 0.50, 6711039, 16777215 }, ;
	{ 0.50, 16777215, 6711039 } }, ;
	{ { 0.50, 16761992, 16777215 }, ;
	{ 0.50, 16777215, 16761992 } } ) }
oBtn4:lTransparent := .t.   
oBtn4:cToolTip =  { "Exit" + CRLF + "Project-edit","EXIT", 1, CLR_BLACK, 14089979 }
oBtn4:SetColor( 0, )

ACTIVATE DIALOG oDlg3 CENTERED ;
ON INIT  WD_BACKGRD( oDlg3, oDlg3:nWidth(), oDlg3:nHeight(), 3, nDColorF, nDColorB, nDGradpos, lDDirect, "Brick.bmp" )

RETURN NIL

// --------------------------

STATIC FUNCTION CLEAR_SEL( oData )
LOCAL nOldPos := ("SET")->(ORDKEYNO())

DBGOTOP()
DO WHILE !EOF()
		NET_RLOCK( 3, 3 )
        IF ("SET")->(ORDKEYNO()) <> nOldPos
				("SET")->LSELECTED = .F.
		ELSE
				("SET")->LSELECTED := .T. 
		ENDIF
		NET_ULOCK()
		DBSKIP(+1)
ENDDO
DBGOTOP()
oData:Refresh()

RETURN( NIL )

// --------  DIALOG - Background ---------------

FUNCTION WD_BACKGRD( oWnd, nWidth, nHeight, nDStyle, nDColorF, nDColorB, nDGradpos, lDDirect, cDBrush, cDImage )
Local hDC, oBrush, aGrad

IF nDStyle = 1
		DEFINE BRUSH oBrush COLOR nDColorF
ENDIF
IF nDStyle = 2
		aGrad := { { nDGradpos, nDColorF, nDColorB }, { nDGradpos, nDColorB, nDColorF } }
		hDC = CREATECOMPATIBLEDC( oWnd:GetDC() )
		hBmp = CREATECOMPATIBLEBITMAP( oWnd:hDC, nWidth, nHeight )
		hBmpOld = SELECTOBJECT( hDC, hBmp )
		GRADIENTFILL( hDC, 0, 0, nHeight, nWidth, aGrad, lDDirect ) // .T: = Vertical
		oBrush = TBrush():New( ,,,, hBmp )
		oWnd:SetBrush( oBrush )
		AEVAL( oWnd:aControls, { | oCtl | IF( oCtl:lTransparent, oCtl:SetBrush( oWnd:oBrush ), ) } )
		SELECTOBJECT( hDC, hBmpOld )
		DELETEDC( hDC )
		oWnd:ReleaseDC()
ENDIF
IF nDStyle = 3
		IF FILE( c_path1 + cDBrush ) 
				DEFINE BRUSH oBrush FILE c_path1 + cDBrush
		ELSE
				MsgAlert( "File : " + cDBrush + CRLF + ;
									"does not exist" + CRLF + ; 
									"to create brush !", "ATTENTION" ) 
				RETURN( NIL )
		ENDIF
ENDIF
IF nDStyle = 4
		IF FILE( c_path1 + cDImage ) 
				DEFINE IMAGE oImage FILE c_path1 + cDImage
				oBrush := TBrush():new( , , , , ResizeBmp( oImage:hBitmap, nWidth, nHeight, .T. ) )
				oImage:End()
		ELSE
				MsgAlert( "File : " + cDBrush + CRLF + ;
									"does not exist" + CRLF + ; 
									"to create brush !", "ATTENTION" ) 
				RETURN( NIL )
		ENDIF
ENDIF
IF nDStyle > 0
		oWnd:SetBrush( oBrush )
		RELEASE BRUSH oBrush 
ENDIF

RETURN( NIL )

// ----------------

STATIC FUNCTION GO_START()

IF FILE( c_Path + "PROJECT.DBF" ) 
		NET_USE ( c_Path + "PROJECT.DBF", "SET", 3,.T. ) 
		DBSELECTAREA("SET")
        ORDCREATE( ,"PROJECT","UPPER(CPROJECT)", ;
	                                {|| UPPER(CPROJECT) } , .F. )
		DBGOTOP()
		DO WHILE !EOF()
				IF ("SET")->LSELECTED = .T.
						EXIT
				ENDIF
				DBSKIP(+1)
		ENDDO
		cBrwPos := ALLTRIM(("SET")->CPROJECT)
ELSE
		MsgAlert( "PROJECT.DBF doesn't exist", "Attention")
		QUIT
ENDIF

RETURN NIL

// ----------------

FUNCTION LOAD_DBF(oDlg, lSkip)

IF lSkip = .T.
		IF ("SET")->(EOF())
				MsgAlert("File EOF!", "SKIP" )
				DBGOTOP()
		ENDIF
		IF ("SET")->(BOF())
				MsgAlert("File BOF !", "SKIP" )
				DBGOBOTTOM()
		ENDIF
ENDIF

cProject				:=	 TRIM(("SET")->CPROJECT)
oDlg:cTitle := "Folder RGB-colors   => " + cProject	
lSelected           := ("SET")->LSELECTED

nResRGB			:= ("SET")->NRESRGB
nBrightGrd		:= ("SET")->NBRIGHTGRD
nResBright		:= ("SET")->NRESBRIGHT
nDarkGrd			:= ("SET")->NDARKGRD
nResDark			:= ("SET")->NRESDARK

nValRGB			:= ("SET")->NVALRGB
cTextRGB			:= ("SET")->CTEXTRGB
cWordRGB		:= ("SET")->CWORDRGB
nBrightRGB		:= ("SET")->NBRIGHTRGB

nGradCol1		:= ("SET")->NGRADCOL1
cGradCol1		:= ("SET")->CGRADCOL1
nGradCol2		:= ("SET")->NGRADCOL2
cGradCol2		:= ("SET")->CGRADCOL2
cGradArr			:= ("SET")->CGRADARR
lGrdDirect			:= ("SET")->LGRDDIRECT
nGradPos			:= ("SET")->NGRADPOS

n1_GradC1		:= ("SET")->N1_GRADC1
n1_GradC2		:= ("SET")->N1_GRADC2
c1_GradArr		:= ("SET")->C1_GRADARR
l1_GradDir		:= ("SET")->L1_GRADDIR
n1_Gradpos		:= ("SET")->N1_GRADPOS
l1_Grad				:= ("SET")->L1_GRAD 

n2_GradC1		:= ("SET")->N2_GRADC1
n2_GradC2		:= ("SET")->N2_GRADC2
c2_GradArr		:= ("SET")->C2_GRADARR
l2_GradDir		:= ("SET")->L2_GRADDIR
n2_Gradpos		:= ("SET")->N2_GRADPOS
l2_Grad 				:= ("SET")->L2_GRAD 

n3_GradC1		:= ("SET")->N3_GRADC1
n3_GradC2		:= ("SET")->N3_GRADC2
c3_GradArr		:= ("SET")->C3_GRADARR
l3_GradDir		:= ("SET")->L3_GRADDIR
n3_Gradpos		:= ("SET")->N3_GRADPOS
l3_Grad 				:= ("SET")->L3_GRAD 

n4_GradC1		:= ("SET")->N4_GRADC1
n4_GradC2		:= ("SET")->N4_GRADC2
c4_GradArr		:= ("SET")->C4_GRADARR
l4_GradDir		:= ("SET")->L4_GRADDIR
n4_Gradpos		:= ("SET")->N4_GRADPOS
l4_Grad 				:= ("SET")->L4_GRAD 

n5_GradC1		:= ("SET")->N5_GRADC1
n5_GradC2		:= ("SET")->N5_GRADC2
c5_GradArr		:= ("SET")->C5_GRADARR
l5_GradDir		:= ("SET")->L5_GRADDIR
n5_Gradpos		:= ("SET")->N5_GRADPOS
l5_Grad 				:= ("SET")->L5_GRAD 

RETURN NIL

// ---------- NET - FUNCTIONS ----------------------------

FUNCTION NET_USE ( cDBName, cAlias, nTrials, lNet )
LOCAL lReturn  := .T.
LOCAL lOpen    := .F.

nTrcount   := nTrials
YesNo := .F.

// SHARED    all Users
// EXCLUSIVE  1 User

IF File( cDBName )
		nTrials := nTrcount
		DO WHILE !lOpen
				DO WHILE .T.
						IF !lNet
								USE &cDBName ALIAS &cAlias NEW EXCLUSIVE
						ELSE
								USE &cDBName ALIAS &cAlias NEW SHARED
						ENDIF
						IF !NetErr()
								lReturn   := .T.
								lOpen     := .T.
								nTrials := 0
						ELSE
								IF lNet = .T.
										Status := "SHARED"
								ELSE
										Status := "EXCLUSIVE"
								ENDIF
								IF nTrcount = nTrials
										xName := WNetGetUser()
										IF MsgYesNo( "Open " + Status + "  of " + upper(cDBName) + " not possible !" + ;
																" try again ?", "Network-error -> &xName !" )
												nTrials := nTrcount
												YesNo := .T.
										ELSE
												nTrials := 0
												YesNo := .F.
										ENDIF
								ENDIF
								IF YesNo = .T.
										nTrials --
										IF nTrials > 0 .AND. nTime > 0
												NET_WAIT ( nTrcount, nTrials, nTime)
										ENDIF
										IF nTrials = 0
												nTrials := nTrcount
										ENDIF
								ELSE
										lReturn   := .F.
										lOpen     := .T.
										nTrials := 0
								ENDIF
						ENDIF
						IF nTrials = 0
								lOpen := .T.
								EXIT
						ENDIF
				ENDDO
		ENDDO
ELSE
		nMsgBox ("File -> " + cDBName + " is missing !", "Attention !")
		SET RESOURCES to
		set _3DLOOK OFF
		FreeLibrary()
		Close database
		QUIT
ENDIF

RETURN lReturn

// ----------------------

FUNCTION NET_WAIT ( nTrcount, nTrials, nTime )

local oMeter, oText1

MsgMeter( { | oMeter, oText1 | ;
SHOW_WAIT(nTrcount, nTrials, nTime, oMeter, oText1) } , ;
"rest trials : " + LTRIM(STR(nTrials)) + ". trial..." )

RETURN nil

// ----------------------

STATIC FUNCTION SHOW_WAIT( nTrcount, nTrials, nTime, oMeter, oText1 )

oMeter:nTotal = nTrcount
nZSek := Seconds()
oText1:SetText( "rest of trials : " + ltrim(str(nTrials)))
oMeter:Set( nTrials )
SysRefresh()
DO WHILE Seconds() < nZSek + nTime
ENDDO

RETURN nil

//-------------------------------------------------------

FUNCTION NET_RLOCK( nTrials, nTime )
LOCAL   lReturn   := .F.
LOCAL   nTrcount   := 0
LOCAL   nZSek     := 0
nTrcount := nTrials

DO WHILE !lReturn
		DO WHILE nTrials > 0
				IF !RLock()
						nTrials --
						IF nTrials > 0 .AND. nTime > 0
								NET_WAIT ( nTrcount, nTrials, nTime )
						ENDIF
				ELSE
						lReturn := .T.
						EXIT
				ENDIF
		ENDDO
		IF nTrials = 0
				IF MsgYesNo( "Not possible, to lock the record !" + ;
									" Try again ?", "Network Error !" )
						nTrials := nTrcount
				ELSE
						lReturn := .F.
						EXIT
				ENDIF
		ENDIF
ENDDO
IF lReturn = .F.
		nMsgBox ("Files are not saved !!!", "Attention !")
ENDIF

RETURN lReturn

//-------------------------------------------------------

FUNCTION NET_ULOCK()

LOCAL   lReturn   := .F.

IF len(Fieldname(1)) > 0                     
		UNLOCK                                      
ENDIF

RETURN lReturn

// ----------------------

FUNCTION NET_CLOSE( nTrials, nTime )

LOCAL lReturn  := .T.
LOCAL lOpen    := .F.

nTtrcount   := nTrials
YesNo    := .F.

cDBName := DBF()

DO WHILE !lOpen
		DO WHILE nTrials > 0
				USE
				IF NetErr()
						nTrials --
						IF MsgYesNo( "Close of file : " + upper(cDBName) + " not possible !" + ;
												" Try again ?", "Network-Error !" )
								lOpen :=.T.
								nTrials := ntrcount
								IF nTrials > 0 .AND. nTime > 0
										NET_WAIT ( nTrcount, nTrials, nTime)
								ENDIF
						ELSE
								lReturn   := .F.
								lOpen     := .T.
								nTrials := 0
						ENDIF
				ELSE
						lReturn   := .T.
						lOpen     := .T.
						nTrials := 0
				ENDIF
		ENDDO
ENDDO

RETURN lReturn

//------------- BMP-Brush -----------

FUNCTION DRAW_BMP( oBitmap, hDC, nStyle, nVColor, nBColor, lDDirect, nMove, cImage ) 
LOCAL aGrad := { { nMove, nVColor, nBColor }, { nMove, nBColor, nVColor } }
LOCAL aRect := GETCLIENTRECT( oBitmap:hWnd )

IF nStyle = 1 // 1. Color
		DEFINE BRUSH oNewbrush COLOR nVColor
		FillRect( oBitmap:hDC, aRect, oNewbrush:hBrush )
		oNewbrush:End()
ENDIF
IF nStyle = 2 // 2. Color
		DEFINE BRUSH oNewbrush COLOR nBColor
		FillRect( oBitmap:hDC, aRect, oNewbrush:hBrush )
		oNewbrush:End()
ENDIF
IF nStyle = 3 // Gradient
		DEFINE BRUSH oNewBrush ;
		COLOR GradientFill( hDC,  0, 0, aRect[3], aRect[4], aGrad, lDDirect ) // .T: = Vertical
		oNewbrush:End()
ENDIF
IF nStyle = 4 // Brush ( stretched )
		IF FILE( c_path1 + cImage )
				DEFINE IMAGE oImage FILENAME c_path1 + cImage 
				nImgWidth := oImage:nWidth 
				nImgHeight := oImage:nHeight 
				nWFactor := aRect[4] / nImgWidth  
				nHFactor := aRect[3] / nImgHeight
	
				oImg0 := FILoadImg( c_path1 + cImage )
				lAlpha := HasAlpha( oImg0 )	

				//cSize := ALLTRIM(STR(oImg:nWidth)) + "x" + ALLTRIM(STR(oImg:nHeight)) + ;
				//		"   Resize-Factor : W = " + ALLTRIM(STR(nFactor1)) + " <> H = " + ALLTRIM(STR(nFactor2))		 
		 
				IF nWFactor > 1 .and. nHFactor > 1 
						nWidth := nImgWidth
						nHeight := nImgHeight
				ENDIF
				IF nWFactor < 1 .and. nHFactor < 1
						IF nWFactor < nHFactor			// Width-factor > Height-factor  
								nWidth := aRect[4]
								nHeight := nImgHeight * nWFactor 
						ELSE							// Width-factor < Height-factor  
								nWidth := nImgWidth * nHFactor
								nHeight := aRect[3]  
						ENDIF
				ENDIF
				IF nWFactor < 1 .and. nHFactor > 1	// 1800x500
						nWidth := aRect[4]
						nHeight := nImgHeight * nWFactor  
				ENDIF
				IF nWFactor > 1 .and. nHFactor < 1	// 600x1000
						nWidth := nImgWidth * nHFactor
						nHeight := aRect[3]
				ENDIF 

				IF lAlpha = .T.
						oImg := ResizeImg( oImg0, nWidth, nHeight )
						ABPaint( hDC, 0, 0, oImg0, 255 )
				ELSE
						PalBmpDraw( hDC, 0, 0, oImage:hBitmap, , nWidth, nHeight )
				ENDIF
				DeleteObject( oImg0 )
				DeleteObject( oImage )
		ELSE
				MsgAlert( "File : " + cImage + CRLF + ;
							"does not exist" + CRLF + ; 
							"to show Image !", "ATTENTION" ) 
		ENDIF
ENDIF

RETURN( NIL )

